/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1998
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *    Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: common-stuff.h,v 1.3 1998/12/20 18:14:34 root Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __COMMON_STUFF_H__
#define __COMMON_STUFF_H__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#ifdef linux
#define _HAVE_ALLOCA  1
#undef  _HAVE_MEMMOVE
#endif

extern void *emalloc (unsigned long), efree (void *);

/* malloc 0-initialized space, never ever returns NULL */
#define XMALLOC(x)	(void*)emalloc (x)
#define XFREE(x)	efree (&(x)) /* reference due to implementation */

#ifdef _HAVE_ALLOCA
#define ALLOCA(x)	alloca (x)
#define DEALLOCA(x)	/* not needed */
#else
#define ALLOCA(x)	XMALLOC (x)
#define DEALLOCA(x)	XFREE (x)
#endif

/* duplicate string, based on secure alloc or alloca */
#define XSTRDUP(s)	strcpy (XMALLOC (strlen (s) + 1), (s))
#define ALLOCASTRDUP(s)	strcpy  (ALLOCA (strlen (s) + 1), (s))

/* stuff for gnugp import files blowfish, md5 etc. */
#define G10ERR_WEAK_KEY       43 /* NOTE: hardcoded intothe cipher modules */
#undef                byte	 /* maybe there is a macro with this name */
typedef unsigned char byte;


#ifdef HAVE_CONFIG_H
# ifdef WORDS_BIGENDIAN
#  define BIG_ENDIAN_HOST 1
# else
#  define LITTLE_ENDIAN_HOST 1
# endif

#else /* not HAVE_CONFIG_H */
# include <endian.h>
# if __BYTE_ORDER == __LITTLE_ENDIAN
#  define LITTLE_ENDIAN_HOST 1
# elif __BYTE_ORDER == __BIG_ENDIAN
#  define BIG_ENDIAN_HOST 1
# else
#  error Neither little nor big endian machine !
# endif
#endif /* HAVE_CONFIG_H */

# include <limits.h>
# if UINT_MAX == 4294967295U
   typedef unsigned int u32;
# elif ULONG_MAX == 4294967295U 
   typedef unsigned long u32;
# else
#  error no typedef for u32
# endif

#endif /* __COMMON_STUFF_H__ */
