/*
 *          Copyright (c) mjh-EDV Beratung, 1996-1998
 *     mjh-EDV Beratung - 63263 Neu-Isenburg - Rosenstrasse 12
 *          Tel +49 6102 328279 - Fax +49 6102 328278
 *                Email info@mjh.teddy-net.com
 *
 *   Author: Jordan Hrycaj <jordan@mjh.teddy-net.com>
 *
 *   $Id: peks-baseXX.c,v 1.1 1998/12/13 21:48:52 root Exp $
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <limits.h>

#include "common-stuff.h"
#include "peks-internal.h"
#include "baseXX.h"


/* ---------------------------------------------------------------------------- *
 *                     public mumeric conversion functions                      *
 * ---------------------------------------------------------------------------- */

char*
mpz2base64 (OP)
     mpz_t *OP;
{
  char *t, *s = ALLOCA (mpz_sizeinbase (*OP, 32) + 2) ;
  mpz_get_str (s, 32, *OP) ;
  t = baseXtoBase64 (s,5) ;
  DEALLOCA (s) ;
  return t;
}


int
base64toMpz (OP, s)
     mpz_t *OP;
     const char *s;
{
  char *t ;
  int n;
  if (s == 0) {
    mpz_set_ui (*OP, 0);
    return 0;
  }
  t = base64toBaseX (s,5) ;
  n = mpz_set_str (*OP, t, 32);
  XFREE (t);
  return !n; /* 1 is ok, 0 is error */
}


char*
uint2base64 (n)
     unsigned long n;
{
  char buf [2 * sizeof (long) + 1];
  sprintf (buf, "%lx", n) ;
  return baseXtoBase64 (buf,4) ;
}


unsigned long
base64toUint (s)
     const char *s;
{
  unsigned long num ;
  char *t, *u, c ;
  if (s == 0)
    return UINT_MAX ;
  t = base64toBaseX (s,4) ;
  num = strtol (t, &u, 16) ;
  c = *u ; /* save char, u points into t */
  XFREE (t) ;
  return c ? UINT_MAX : num ; 
}
 
